<?php  if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Handle Wizard colors
 *
 * @copyright   Copyright (C) 2018, Echo Plugins
 * @license http://opensource.org/licenses/gpl-2.0.php GNU Public License
 */
class EPKB_KB_Wizard_Colors {

	function __construct() {
		add_action( 'epkb-wizard-main-page-color-selection-container',      array( $this, 'wizard_main_page_colors_sidebar'), 10, 3 );
		add_action( 'epkb-wizard-article-page-color-selection-container',   array( $this, 'wizard_article_page_colors'), 10, 3 );
	}

	/**
	 * Show Wizard page colors for Main Page
	 *
	 * @param $args
	 *
	 * @noinspection PhpUnused*/
	public function wizard_main_page_colors_sidebar( $args ) {

		$kb_config = $args['config'];
		$feature_specs = EPKB_KB_Config_Specs::get_fields_specification( $kb_config['id'] );
		$form = new EPKB_KB_Config_Elements();

		// Colors
		$arg1_input_text_field = $feature_specs['search_text_input_background_color'] + array( 
			'value' => $kb_config['search_text_input_background_color'], 
			'current' => $kb_config['search_text_input_background_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-search-box input[type=text]',
				'style_name' => 'background'
			)
		);
		
		$arg2_input_text_field = $feature_specs['search_text_input_border_color']     + array( 
			'value' => $kb_config['search_text_input_border_color'], 
			'current' => $kb_config['search_text_input_border_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-search-box input[type=text]',
				'style_name' => 'border-color'
			)
		);

		$arg1_button = $feature_specs['search_btn_background_color']  + array( 
			'value' => $kb_config['search_btn_background_color'],
			'current' => $kb_config['search_btn_background_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-search-box button',
				'style_name' => 'background'
			)
		);
		
		$arg2_button = $feature_specs['search_btn_border_color'] + array( 
			'value' => $kb_config['search_btn_border_color'],
			'current' => $kb_config['search_btn_border_color'],
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-search-box button',
				'style_name' => 'border-color'
			)
		);

		$arg1_sub_category = $feature_specs['section_category_font_color'] + array( 
			'value' => $kb_config['section_category_font_color'], 
			'current' => $kb_config['section_category_font_color'], 
			'class' => 'ekb-color-picker',
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-category-level-2-3__cat-name',
				'style_name' => 'color'
			)
		);
		
		$arg2_sub_category = $feature_specs['section_category_icon_color'] + array( 
			'value' => $kb_config['section_category_icon_color'], 
			'current' => $kb_config['section_category_icon_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-category-level-2-3>i',
				'style_name' => 'color'
			)
		);

		$arg1_category_box_heading = $feature_specs['section_head_font_color'] + array( 
			'value' => $kb_config['section_head_font_color'],
			'current' => $kb_config['section_head_font_color'],
			'class' => 'ekb-color-picker',
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .section-head .epkb-cat-name',
				'style_name' => 'color'
			)
		);
		
		$arg2_category_box_heading = $feature_specs['section_head_background_color']  + array( 
			'value' => $kb_config['section_head_background_color'],
			'current' => $kb_config['section_head_background_color'],
			'class' => 'ekb-color-picker',
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .section-head',
				'style_name' => 'background-color'
			)
		);

		$arg1_article_list = $feature_specs['section_body_background_color'] + array( 
			'value' => $kb_config['section_body_background_color'],
			'current' => $kb_config['section_body_background_color'],
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-top-category-box',
				'style_name' => 'background-color'
			)
		);
		
		$arg2_article_list = $feature_specs['section_border_color'] + array( 
			'value' => $kb_config['section_border_color'],
			'current' => $kb_config['section_border_color'],
			'class' => 'ekb-color-picker',
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-top-category-box',
				'style_name' => 'border-color'
			)
		);

		$arg1_articles = $feature_specs['article_font_color'] + array( 
			'value' => $kb_config['article_font_color'], 
			'current' => $kb_config['article_font_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .eckb-article-title',
				'style_name' => 'color'
			)
		);
		$arg2_articles = $feature_specs['article_icon_color'] + array( 
			'value' => $kb_config['article_icon_color'], 
			'current' => $kb_config['article_icon_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color' ,
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .eckb-article-title>i',
				'style_name' => 'color'
			)
		);

		// Search Box Colors
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Search Box',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array (
				'0' => $form->text( $feature_specs['search_title_font_color'] + array(
						'value'             => $kb_config['search_title_font_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 .epkb-doc-search-container__title',
							'style_name' => 'color'
						)
					) ),
				'1' => $form->text( $feature_specs['search_background_color'] + array(
						'value'             => $kb_config['search_background_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 .epkb-doc-search-container',
							'style_name' => 'background-color'
						)
					) ),
				'2' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Input Text Field',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_input_text_field, $arg2_input_text_field ),

				'3' => $form->text_fields_horizontal( array(
					'id'                => 'button',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Search Button',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_button, $arg2_button ),
			)
		));

		/* will be changed with js for different templates
		// EPKB_KB_Config_Layout_Tabs::LAYOUT_NAME
		$kb_main_page_layout = EPKB_KB_Config_Layouts::get_kb_main_page_layout_name( $kb_config );
		if ( $kb_main_page_layout == EPKB_KB_Config_Layout_Tabs::LAYOUT_NAME ) {
			$this->get_tabs_color_set( $kb_config, $feature_specs );
		}
		*/
		$this->get_tabs_color_set( $kb_config, $feature_specs );

		// CATEGORIES - Colors
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Categories',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array (

				'0' => $form->text( $feature_specs['background_color'] + array(
						'value'             => $kb_config['background_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 #epkb-content-container',
							'style_name' => 'background-color'
						)
					) ),

				'1' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Category Box Heading',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_category_box_heading, $arg2_category_box_heading ),

				'2' => $form->text( $feature_specs['section_head_category_icon_color'] + array(
						'value'             => $kb_config['section_head_category_icon_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 .section-head .epkb-cat-icon',
							'style_name' => 'color'
						)
					) ),

				'3' => $form->text( $feature_specs['section_head_description_font_color'] + array(
						'value'             => $kb_config['section_head_description_font_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 .epkb-category-level-1+p',
							'style_name' => 'color'
						)
					) ),

				'4' => $form->text( $feature_specs['section_divider_color'] + array(
						'value'             => $kb_config['section_divider_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-3 .section-head',
							'style_name' => 'border-bottom-color'
						)
					) ),

				'5' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Sub Category',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_sub_category, $arg2_sub_category ),
			)
		));

		// Articles
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Article',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array (
				'0' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Article Container',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_article_list, $arg2_article_list ),

				'1' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Articles',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_articles, $arg2_articles ),
			)
		));
	}

	private function get_tabs_color_set( $kb_config, $feature_specs ) {

		$form = new EPKB_KB_Config_Elements();

		$arg1_active_tab = $feature_specs['tab_nav_active_font_color'] + array( 
			'value' => $kb_config['tab_nav_active_font_color'], 
			'current' => $kb_config['tab_nav_active_font_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'tab_nav_active_font_color',
			)
		);
		
		$arg2_active_tab = $feature_specs['tab_nav_active_background_color'] + array( 
			'value' => $kb_config['tab_nav_active_background_color'], 
			'current' => $kb_config['tab_nav_active_background_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'tab_nav_active_background_color',
			)
		);
		
		$arg3_active_tab = $feature_specs['tab_nav_border_color'] + array( 
			'value' => $kb_config['tab_nav_border_color'], 
			'current' => $kb_config['tab_nav_border_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'tab_nav_border_color',
			)
		);

		$arg1_inactive_tabs = $feature_specs['tab_nav_font_color'] + array( 
			'value' => $kb_config['tab_nav_font_color'], 
			'current' => $kb_config['tab_nav_font_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-nav-tabs .epkb-category-level-1, .epkb-wizard-step-3 .epkb-nav-tabs .epkb-category-level-1+p',
				'style_name' => 'color'
			)
		); 
		
		$arg2_inactive_tabs = $feature_specs['tab_nav_background_color'] + array( 
			'value' => $kb_config['tab_nav_background_color'], 
			'current' => $kb_config['tab_nav_background_color'], 
			'class' => 'ekb-color-picker',
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => '.epkb-wizard-step-3 .epkb-main-nav, .epkb-wizard-step-3 .epkb-nav-tabs',
				'style_name' => 'background-color'
			)
		);


		// TABS - Colors
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Tabs',
			'class'             => 'epkb-wizard-colors epkb-accordion-body tabs-colors',
			'inputs'            => array(
				'0' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Active Tab',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_active_tab, $arg2_active_tab, $arg3_active_tab ),
				'1' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Inactive Tabs',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_inactive_tabs, $arg2_inactive_tabs )
			)
		));
		//Tabs


		// Category Boxes

		//Heading
		//TODO Add: Top Level Category Icon:            section_head_category_icon_color
		//TODO Add: Category Box Heading - Text:        section_head_font_color
		//TODO Add: Category Box Heading - Background:  section_head_background_color
		//TODO Add: Category Description:               section_head_description_font_color

		//Body
		//TODO Add: Sub-category - Text:  section_category_font_color
		//TODO Add: Sub-category - Icon:  section_category_icon_color


	}

	/**
	 * Wizard colors for Article Page
	 * @param $args
	 *
	 * @noinspection PhpUnused*/
	public function wizard_article_page_colors( $args ) {

		$kb_config = $args['config'];
		$feature_specs = EPKB_KB_Config_Specs::get_fields_specification( $kb_config['id'] );
		$form = new EPKB_KB_Config_Elements();

		// FEATURES - TOC - COLORS
		$arg1_active_heading = $feature_specs['article_toc_active_bg_color'] + array( 
			'value' => $kb_config['article_toc_active_bg_color'],
		    'current' => $kb_config['article_toc_active_bg_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'article_toc_active_bg_color',
			)
		);
		
		$arg2_active_heading = $feature_specs['article_toc_active_text_color'] + array( 
			'value' => $kb_config['article_toc_active_text_color'],
		    'current' => $kb_config['article_toc_active_text_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'article_toc_active_text_color',
			)
		);
		
		$arg1_cursor_hover = $feature_specs['article_toc_cursor_hover_bg_color'] + array( 
			'value' => $kb_config['article_toc_cursor_hover_bg_color'],
			'current' => $kb_config['article_toc_cursor_hover_bg_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'article_toc_cursor_hover_bg_color',
				'style_name' => 'background-color'
			)
		);
		
		$arg2_cursor_hover = $feature_specs['article_toc_cursor_hover_text_color'] + array( 
			'value' => $kb_config['article_toc_cursor_hover_text_color'],
			'current' => $kb_config['article_toc_cursor_hover_text_color'], 
			'class' => 'ekb-color-picker', 
			'text_class' => 'epkb-wizard-single-color',
			'data' => array(
				'wizard_input' => '1',
				'target_selector' => 'article_toc_cursor_hover_text_color',
				'style_name' => 'color'
			)
		);
		
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'TOC',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array(
				'1' => $form->text( $feature_specs['article_toc_text_color'] + array(
						'value'             => $kb_config['article_toc_text_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-article-toc__inner a',
							'style_name' => 'color'
						)
					) ),
				'2' => $form->text( $feature_specs['article_toc_background_color'] + array(
						'value'             => $kb_config['article_toc_background_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-article-toc__inner',
							'style_name' => 'background-color'
						)
					) ),
				'3' => $form->text( $feature_specs['article_toc_border_color'] + array(
						'value'             => $kb_config['article_toc_border_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-article-toc__inner',
							'style_name' => 'border-color'
						)
					) ),
				'4' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Active Heading',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_active_heading, $arg2_active_heading ),
				'5' => $form->text_fields_horizontal( array(
					'id'                => 'input_text_field',
					'input_class'       => 'ekb-color-picker',
					'label'             => 'Cursor Hover',
					'input_group_class' => 'epkb-wizard-dual-color',
				), $arg1_cursor_hover, $arg2_cursor_hover )
			)
		));

		// BACK NAVIGATION - COLORS
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Back Navigation',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array(
				'0' => $form->text( $feature_specs['back_navigation_text_color'] + array(
						'value'             => $kb_config['back_navigation_text_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button a, .epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button',
							'style_name' => 'color'
						)
					) ),
				'1' => $form->text( $feature_specs['back_navigation_bg_color'] + array(
						'value'             => $kb_config['back_navigation_bg_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button a, .epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button',
							'style_name' => 'background-color'
						)
					) ),
				'2' => $form->text( $feature_specs['back_navigation_border_color'] + array(
						'value'             => $kb_config['back_navigation_border_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button a, .epkb-wizard-step-4 .eckb-navigation-back .eckb-navigation-button',
							'style_name' => 'border-color'
						)
					) )
			)
		));

		// FEATURES - Breadcrumb - COLORS
		$form->option_group_wizard( $feature_specs, array(
			'option-heading'    => 'Breadcrumb',
			'class'             => 'epkb-wizard-colors epkb-accordion-body',
			'inputs'            => array(
				'0' => $form->text( $feature_specs['breadcrumb_text_color'] + array(
						'value'             => $kb_config['breadcrumb_text_color'],
						'input_class'       => 'ekb-color-picker',
						'input_group_class' => 'epkb-wizard-single-color',
						'data' => array(
							'wizard_input' => '1',
							'target_selector' => '.epkb-wizard-step-4 .eckb-breadcrumb-link span:not(.eckb-breadcrumb-link-icon)',
							'style_name' => 'color'
						)
					) )
			)
		));
	}


}